'use strict';

////////// constants for the app //////////////

// throttling of refresh and meters
const kMaxRefreshInterval = 1/60; // if you want to throttle drawing
const kMaxMeterInterval = 1/30; // if you want to throttle meter drawing
var kCanvasScale = 2;


////////// global decls //////////////
var storage; // Storage()
var afd;    //AnimationFrameDispatcher();
var meters; //MeterStore;
var evSys;  // Events();
var gen5Lib; //Gen5Lib
var device; // Device
var welcome; // WelcomeView
var ds;     // DataStore;
var modal;  // FXModalCanvas();
var chFxEdit; // ChFxEditView();
var busFxEdit; // BusFxEditView();
var mixMgr; // MixMgr;
var keyFilter; // KeyFilter
var isIOS = false;
var isMobile = false;
var updater; // Updater

const kMixBG = "rgb(35, 38, 44)";
const kBusStripBG = "rgb(47, 52, 59)";
const kBlackBG = "black";//
const kNavBtnGrey = "rgb(70, 74, 83)";

// dimensions
const kFaderL = 50;
const kBusStripW = 130;
const kBusStripWSmall = 50;
const kChStripW = 105;
const kFxChStripW = 1.5 * kChStripW;
const kNumChStrips = 30;
const kTabSelW = 220;
const kThumbH = 55;
const kFxThumbH = 1.5 * kThumbH;
const kFaderCapRadius = 20;

const kTabEv = "tabEv";
const kHome = "kHome";
const kDev = "kDev";
const kISetup = "kISetup";
const kOSetup = "kOSetup";
const kAdv = "kAdv";
const kTabBG = "rgb(17, 21, 24)";
const kTabTxt = "rgb(127,127,127)";
const kTabTxtSel = "white";
const kTabSel = "rgb(37,38,39)";
const kMenuBlue = "rgb(20,122,255)";

const kToggleBlue = "rgb(52,141,221)";
const kToggleYellow = "rgb(234,226,23)";
const kToggleRed = "rgb(207,31,37)";
const kMeterTickColor = "rgb(108,109,110)";
const kToggleDefault = "rgb(158,159,160)";

const kEQColors = [
  'rgb(0, 255, 251)',
  'rgb(187, 157, 255)',
  'rgb(167, 44, 88)',
  'rgb(1, 114, 241)',
];

const kMeterBlue  = "rgb(79, 165, 255)";
const kGridColor = 'rgb(63,71,82)';
const kEQLabel = 'rgb(116, 117, 135)';
const kEQValue = 'rgb(185, 191, 217)';
const kEQControlGray = 'rgba(99, 105, 120, 0.7)';
const kEQCurveColors = [
  'rgba(0, 255, 251, 0.3)',
  'rgba(187, 157, 255, 0.3)',
  'rgba(167, 44, 88, 0.3)',
  'rgba(1, 114, 241, 0.3)',
];

const kDynCtrlBG = 'rgb(35,38,44)';
const kGateCtrl = 'rgb(0,207,213)';
const kGateCtrlDisabled  = 'rgba(0,207,213, 0.2)';
const kCompCtrl = 'rgb(239,183,28)';
const kCompCtrlDisabled  = 'rgba(239,183,28, 0.2)';
const kGRMeter = "rgb(225,65,65)";
const kLMeter = "rgb(78,165,255)";

const kEmptyBG = "rgb(27,29,28)";
const kBusColors = [
  'rgb(200, 200, 200)', // main 1 white
  'rgb(200, 200, 200)', // main 2
  'rgb(255, 122, 34)', // anlg 1 orange
  'rgb(255, 122, 34)', // anlg 2
  'rgb(230, 200, 50)', // anlg 3 yellow
  'rgb(230, 200, 50)', // anlg 4
  'rgb(99, 210, 165)',// anlg 5 green
  'rgb(99, 210, 165)',// anlg 6
  'rgb(1, 146, 248)',// anlg 7 blue
  'rgb(1, 146, 248)',// anlg 8
  'rgb(214, 23, 1)', // phones 1 red
  'rgb(214, 23, 1)', // phones 2
  'rgb(154, 109, 176)', // rvb 1 purple
  'rgb(154, 109, 176)', // rvb 2
];

const kFxEditBG = 'rgb(18, 22, 25)';
const kFxHeight = 608;
const kFxWidth = 1080;

const kBusEQFxType = "EQBus";
const kEQFxType = "EQ";
const kDynamicsFxType = "Dynamics";
const kReverbFxType = "Reverb";

// consts for the location of input meter indexes
const kMIPreGate = 0; // post eq
const kMIGateReduction = 1; 
const kMIPreComp = 2; // post eq or post post gate
const kMICompReduction = 3;
const kMIPostFx = 4;

var kScrollBarSize = 40;

